import { QToast } from '../e2elib/lib/api/pageobjects/qtoast.component';

export class ToastSOP extends QToast {
  public toast = new QToast();
  public constructor() {
    super();
  }

  /**
   * Verify the toast message and closes it.
   *
   * @param message The toast message content to verify.
   */
  public async verifyToastMessageAndClose(message: string): Promise<void> {
    const lastToastMsg = await this.toast.getToastMessage();
    expect(lastToastMsg).toBe(message, `Expect toast message: ${message}. Actual toast message: ${lastToastMsg}.`);
    await this.toast.close();
  }
}

// Step description to re-use in spec file to prevent scriptor re-write each time
const stepToast = {
  verifyToastMessageAndClose: (message: string): string => `Verify if toast message present is "${message}" and close it.`,
};

export { stepToast as StepToast };
